From a84ad1365d36462dfdf12c400b39df863cc3448e Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Mar 27 2021 05:14:57 +0000
Subject: [PATCH 2220/2232] Merge pull request #785 from dtolnay/pinctype


Handle pinned reference argument pointing to improper ctype
---

diff --git a/macro/src/expand.rs b/macro/src/expand.rs
index 042fdcb..1ffd44f 100644
--- a/macro/src/expand.rs
+++ b/macro/src/expand.rs
@@ -506,10 +506,18 @@ fn expand_cxx_function_shim(efn: &ExternFn, types: &Types) -> TokenStream {
                     false => quote!(::cxx::private::RustVec::from_ref(#var)),
                     true => quote!(::cxx::private::RustVec::from_mut(#var)),
                 },
-                inner if types.is_considered_improper_ctype(inner) => match ty.mutable {
-                    false => quote!(#var as *const #inner as *const ::std::ffi::c_void),
-                    true => quote!(#var as *mut #inner as *mut ::std::ffi::c_void),
-                },
+                inner if types.is_considered_improper_ctype(inner) => {
+                    let var = match ty.pinned {
+                        false => quote!(#var),
+                        true => quote!(::std::pin::Pin::into_inner_unchecked(#var)),
+                    };
+                    match ty.mutable {
+                        false => {
+                            quote!(#var as *const #inner as *const ::std::ffi::c_void)
+                        }
+                        true => quote!(#var as *mut #inner as *mut ::std::ffi::c_void),
+                    }
+                }
                 _ => quote!(#var),
             },
             Type::Ptr(ty) => {
diff --git a/tests/ffi/module.rs b/tests/ffi/module.rs
index cd9fc2b..089a5c5 100644
--- a/tests/ffi/module.rs
+++ b/tests/ffi/module.rs
@@ -32,6 +32,9 @@ pub mod ffi2 {
 
         fn c_take_trivial_ptr(d: UniquePtr<D>);
         fn c_take_trivial_ref(d: &D);
+        fn c_take_trivial_mut_ref(d: &mut D);
+        fn c_take_trivial_pin_ref(d: Pin<&D>);
+        fn c_take_trivial_pin_mut_ref(d: Pin<&mut D>);
         fn c_take_trivial_ref_method(self: &D);
         fn c_take_trivial_mut_ref_method(self: &mut D);
         fn c_take_trivial(d: D);
diff --git a/tests/ffi/tests.cc b/tests/ffi/tests.cc
index 831097d..a4d8c47 100644
--- a/tests/ffi/tests.cc
+++ b/tests/ffi/tests.cc
@@ -604,6 +604,18 @@ void c_take_trivial_ref(const D &d) {
   }
 }
 
+void c_take_trivial_mut_ref(D &d) {
+  (void)d;
+}
+
+void c_take_trivial_pin_ref(const D &d) {
+  (void)d;
+}
+
+void c_take_trivial_pin_mut_ref(D &d) {
+  (void)d;
+}
+
 void D::c_take_trivial_ref_method() const {
   if (d == 30) {
     cxx_test_suite_set_correct();
diff --git a/tests/ffi/tests.h b/tests/ffi/tests.h
index eaa4361..a5d8bc0 100644
--- a/tests/ffi/tests.h
+++ b/tests/ffi/tests.h
@@ -184,6 +184,9 @@ size_t c_get_use_count(const std::weak_ptr<C> &weak) noexcept;
 
 void c_take_trivial_ptr(std::unique_ptr<D> d);
 void c_take_trivial_ref(const D &d);
+void c_take_trivial_mut_ref(D &d);
+void c_take_trivial_pin_ref(const D &d);
+void c_take_trivial_pin_mut_ref(D &d);
 void c_take_trivial(D d);
 
 void c_take_trivial_ns_ptr(std::unique_ptr<::G::G> g);

